<template>

    <div ref="scrollContainer" class="scroll-container w-100">
        <!-- pull to refresh -->
        <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
        <div class="container mx-auto p-5 mb-12">
            <!-- page title -->
            <PageTitle title="Devices" />

            <!-- filter by rooms -->
            <div class="flex flex-row justify-between items-center mb-5" style="overflow-x: auto; cursor: pointer;">
                <div :class="'whitespace-nowrap p-3 m-3 badge ' + (selectedRoom === 'all' ? 'badge-neutral' : 'badge-outline')" @click="filterByRoom('all')">All</div>
                <div v-for="room in ROOMS" :class="'whitespace-nowrap badge p-3 m-3 ' + (selectedRoom === room.value ? 'badge-neutral' : 'badge-outline')" @click="filterByRoom(room.value)" v-html="room.text"></div>
            </div>

            <Alert v-if="showError" type="error" title="Error" :body="errorText" />

            <!-- list of devices -->
            <GenericWidget 
                v-for="item in list" 
                :itemId="item.id" 
                :itemName="item.name" 
                :itemIcon="item.icon" 
                :itemType="item.type" 
                :itemRoom="item.room"
                :itemRoomName="getRoomNameBySlug(item.room)"
                :itemStatus="item.status"
                :itemCurrConsumption="item.value"
                :itemWeekConsumption="item.weekConsumptions"
                :key="item.id"
                @updateStatus="toggleStatus" 
                @editEvent="openEditModal(item)" 
                @deleteEvent="openDeleteModal(item)"
                @closeModal="closeModal"
                > 
            </GenericWidget>

            <!-- Loading -->
            <div v-if="loading">
                <div class="skeleton h-32 w-full flex flex-col justify-center">
                    <button class="">
                        <span class="loading loading-spinner"></span>
                        Loading Devices...
                    </button>
                </div>
            </div>
        </div>

        <!-- modals -->
        <Modal id="device" :modalData="modalData" @onSubmit="handleSubmit" @closeModal="closeModal" />
        <!-- floating action button -->
        <FloatingActionButton @click="openCreateModal" />
    </div>
</template>
  
<script>
    import GenericWidget from '@/components/GenericWidget.vue';
    import PullToRefresh from '@/components/PullToRefresh.vue';
    import PageTitle from '@/components/PageTitle.vue';
    import FloatingActionButton from '@/components/FloatingActionButton.vue';
    import Modal from '@/components/Modal.vue';
    import Alert from '@/components/Alert.vue';
    
    import ROOMS from '@/assets/rooms.json';
    import ICONS from '@/assets/icons.json';
    import DEVICE_TYPES from '@/assets/deviceTypes.json'
    
    export default {
        components: {
            GenericWidget,
            PullToRefresh,
            PageTitle,
            FloatingActionButton,
            Modal,
            Alert
        },
        data() {
            return {
                list: [], // array of items
                scrollContainer: {}, // useful element for pull-to-refresh

                // props for modal component...
                modalData: {},
                showError: false,
                selectedRoom: "all",
                loading: false,

                socket: null
            }
        },
        mounted() {
            // prepare the pull-to-refresh
            this.scrollContainer = this.$refs.scrollContainer
            this.$refs.pullRefresh.init()
            
            this.ROOMS = ROOMS

            // listen for backend realtime updates
            this.socket = new WebSocket(this.WS_URL);
            this.socket.onopen = () => {
                console.log('WebSocket Client Connected');
            };
            this.socket.onmessage = (msg) => {
                msg = JSON.parse(msg.data)
                
                if (msg.type === "REGISTERED_CONSUMPTION") {
                    let refDeviceId = msg.device;
                    let numberOfConsumptions = parseInt(msg.noConsumption);
                    let newValue = parseFloat(msg.value);

                    let device = this.list.find(dev => dev.id === refDeviceId);
                    if(device){
                        let unitOfMeasure = device.value.split(" ").slice(1).join(" ");
                        device.weekConsumptions = (((parseFloat(device.weekConsumptions.split(" ")[0]) * numberOfConsumptions) + newValue) / (numberOfConsumptions + 1)).toFixed(2) + " " + unitOfMeasure;
                        device.value = newValue.toFixed(2) + " " + unitOfMeasure;
                        
                        for(let i = 0; i < this.list.length; i++){
                            if(this.list[i].id === refDeviceId){
                                this.list[i] = device;
                                break;
                            }
                        }
                    }
                } else if (msg.type === "STATUS_UPDATE") {
                    let refDeviceId = msg.device;
                    let newStatus = msg.status;

                    let device = this.list.find(dev => dev.id === refDeviceId);
                    if(device){
                        device.status = newStatus;
                        for(let i = 0; i < this.list.length; i++){
                            if(this.list[i].id === refDeviceId){
                                this.list[i] = device;
                                break;
                            }
                        }
                    }
                }

                /*if(this.list.find(dev => dev.id === data.device)){
                    if (data.type === "STATUS_UPDATE") {
                        this.fetchData()
                    } else if(data.type === "REGISTERED_CONSUMPTION") {
                        this.fetchData()
                    }
                }*/
            };

            // fetch the data for the first time
            this.fetchData()
        },
        methods: {
            /**
             * REST API calls
             */
            async fetchData() {
                // GET /devices
                var self = this;
                self.loading = true;
                self.list = []

                try {
                    const {data} = await self.$axios.get((self.selectedRoom == "all" ? '/devices' : '/devices/findByRoom?room=' + self.selectedRoom))
                    self.showError = false
                    self.list = data

                    if(self.socket !== null){
                        self.socket.send(JSON.stringify({
                            devices: self.list.map(dev => dev.id)
                        }));
                    }
                } catch (error) {
                    self.showError = true
                    self.errorText = error.response.data.message || "Undefined Error";
                } finally {
                    setTimeout(() => {
                        this.$refs.pullRefresh.refreshSuccess()
                    }, 2000)
                    self.loading = false;
                    this.$forceUpdate();
                }

            },
            create(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()

                // POST /devices
                var self = this;
                self.$axios.post('/devices', item).then(async function (response) {
                    self.$toast.success("Device successfully created! From now on, we assume that the device is associated to the app and you will have access to it using a fictitious API interface.");
                    self.fetchData()
                    self.closeModal()
                }).catch(function (error) {
                    self.$toast.error(error.response.data.message);
                });
            },
            edit(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()

                // PUT /devices
                var self = this;
                self.$axios.put('/devices', item).then(async function (response) {
                    self.$toast.success("Device updated successfully!");
                    self.fetchData()
                    self.closeModal()
                }).catch(function (error) {
                    self.$toast.error(error.response.data.message);
                });
            },
            remove(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()
                
                // DELETE /devices
                var self = this;
                self.$axios.delete('/devices', {data: item})
                .then(async (response) => {
                    self.$toast.success("Device deleted successfully!");
                    self.list = self.list.filter(r => r.id !== item.id);
                    // Check if the list is empty and update the error message
                    if (self.list.length === 0) {
                        self.showError = true;
                        self.errorText = "No devices found.";
                    }
                }).catch(async (error) => {
                    // handle error
                    if (self.list.length === 0) {
                        self.showError = true;
                        self.errorText = "No routines found.";
                    } else {
                        self.showError = true;
                        self.$toast.error(error.response.data.message);
                    }
                });
                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            toggleStatus(newItem) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()

                // PUT /devices
                var self = this;
                self.$axios.put('/devices', newItem).then(async function (response) {
                    self.$toast.success("Status update successfully!");
                }).catch(function (error) {
                    self.$toast.error(error.response.data.message);
                });
            },

            filterByRoom(room) {
                this.selectedRoom = room
                this.fetchData()
            },
            /**
             * Functions that create the "fields" and "buttons" props for the modal component, then open the modal.
             */
            openCreateModal() {
                // name, type, status, room, icon
                this.modalData = {
                    id: "createDevice",
                    title: "Create Device",
                    text: "Fill all the fields in this form to create a new device.",
                    fields: [
                        {
                            label: 'Name',
                            type: 'text',
                            placeholder: 'Device Name (e.g. Samsung Television)',
                            value: '',
                            required: true,
                            id: 'name',
                        },
                        {
                            label: '',
                            type: 'hidden',
                            placeholder: '',
                            value: 'active',
                            required: true,
                            id: 'status'
                        },
                        {
                            label: 'Type',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'type',
                            items: DEVICE_TYPES,
                            grouped: true
                        },
                        {
                            label: 'Room',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'room',
                            items: ROOMS
                        },
                        {
                            label: 'Icon',
                            type: 'select_image',
                            placeholder: '',
                            required: true,
                            id: 'icon',
                            items: ICONS,
                            value: ""
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "create"
                }

                // opens the (creation) form
                device.showModal()
            },
            openEditModal(item) {
                // id, name, type, status, room, icon
                this.modalData = {
                    id: "editDevice",
                    title: "Edit Device",
                    text: "Fill all the field in this form to edit the device.",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.id,
                            required: true,
                            id: 'id',
                        },
                        {
                            label: 'Name',
                            type: 'text',
                            placeholder: 'Device Name (e.g. Samsung Television)',
                            value: item.name,
                            required: true,
                            id: 'name',
                        },
                        {
                            label: '',
                            type: 'hidden',
                            value: item.status,
                            required: true,
                            id: 'status'
                        },
                        {
                            label: 'Type',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'type',
                            items: DEVICE_TYPES,
                            value: item.type,
                            grouped: true
                        },
                        {
                            label: 'Room',
                            type: 'select_textual',
                            required: true,
                            id: 'room',
                            value: item.room,
                            items: ROOMS
                        },
                        {
                            label: 'Icon',
                            type: 'select_image',
                            required: true,
                            id: 'icon',
                            value: item.icon,
                            items: ICONS
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "edit"
                }

                // opens the form
                device.showModal()
            },
            openDeleteModal(item) {
                // forms for item deletion
                this.modalData = {
                    id: "deleteDevice",
                    title: "Delete Device",
                    text: "Are you sure you want to delete this device? By deleting this device, all the associated routines will be deleted too together with all the activities (and all their conditions).",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.id,
                            required: true,
                            id: 'id',
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "remove"
                }

                device.showModal()
            },
            getRoomNameBySlug(slug) {
                return ROOMS.find(item => item.value === slug).text
            },
            /**
             * Generic function that closes all the modals.
             */
            closeModal() { device.close() },
            handleSubmit(data){ this[this.modalData.onSubmit](data) },
        }
    };
</script>